//
//  AppDelegate.m
//  Loading Data From Other Bundles
//
//  Created by Vandad Nahavandipoor on 18/08/2011.
//  Copyright (c) 2011 Pixolity Ltd. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate

@synthesize window = _window;

//- (BOOL)            application:(UIApplication *)application 
//  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
//  
//  NSString *resourcesBundlePath = 
//  [[NSBundle mainBundle] pathForResource:@"Resources"
//                                  ofType:@"bundle"];
//  
//  if ([resourcesBundlePath length] > 0){
//    
//    NSBundle *resourcesBundle = [NSBundle bundleWithPath:resourcesBundlePath];
//    
//    if (resourcesBundle != nil){
//      
//      NSString *pathToAlanSugarImage = 
//      [resourcesBundle pathForResource:@"AlanSugar"
//                                ofType:@"png"
//                           inDirectory:@"Images"];
//      
//      if ([pathToAlanSugarImage length] > 0){
//        
//        UIImage *image = [UIImage imageWithContentsOfFile:pathToAlanSugarImage];
//        
//        if (image != nil){
//          NSLog(@"Wczytanie obrazu z bundle zakończyło się powodzeniem.");
//        } else {
//          NSLog(@"Wczytanie obrazu z bundle zakończyło się niepowodzeniem.");
//        }
//        
//      } else {
//        NSLog(@"Nie znaleziono wskazanego pliku w bundle.");
//      }
//      
//    } else {
//      NSLog(@"Nie udało się wczytać pliku z bundle.");
//    }
//    
//  } else {
//    NSLog(@"Nie znaleziono wskazanego bundle.");
//  }
//  
//  self.window = [[UIWindow alloc] initWithFrame:
//                 [[UIScreen mainScreen] bounds]];
//  
//  self.window.backgroundColor = [UIColor whiteColor];
//  [self.window makeKeyAndVisible];
//  return YES;
//}

/* 2 */
- (BOOL)            application:(UIApplication *)application 
didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
  
  NSString *resourcesBundlePath = 
  [[NSBundle mainBundle] pathForResource:@"Resources"
                                  ofType:@"bundle"];
  
  if ([resourcesBundlePath length] > 0){
    
    NSBundle *resourcesBundle = [NSBundle bundleWithPath:resourcesBundlePath];
    
    if (resourcesBundle != nil){
      
      NSArray *PNGPaths = [resourcesBundle pathsForResourcesOfType:@"png"
                                                   inDirectory:@"images"];
      
      [PNGPaths
       enumerateObjectsUsingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
         NSLog(@"Ścieżka dostępu %lu = %@", (unsigned long)idx+1, obj);
       }];
      
    } else {
      NSLog(@"Nie udało się wczytać bundle.");
    }
    
  } else {
    NSLog(@"Nie znaleziono wskazanego bundle.");
  }
  
  self.window = [[UIWindow alloc] initWithFrame:
                 [[UIScreen mainScreen] bounds]];
  
  self.window.backgroundColor = [UIColor whiteColor];
  [self.window makeKeyAndVisible];
  return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy aplikacja przechodzi ze stanu aktywnego do nieaktywnego. Może być wywołana w określonych sytuacjach (na przykład w chwili odbywania rozmowy telefonicznej lub po otrzymaniu wiadomości SMS) bądź kiedy użytkownik kończy działanie aplikacji. Metoda rozpoczyna proces przejścia do stanu pozostania w tle. Tę metodę można wykorzystać do wstrzymania wykonywania bieżących zadań, wyłączenia liczników czasu, zmniejszenia liczby klatek generowanych przez OpenGL ES. W grach ta metoda powinna być użyta do wstrzymania gry (pauza).
   */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
  /*
   Tę metodę należy wykorzystać do zwolnienia zasobów współdzielonych, zapisania danych użytkownika, wyzerowania liczników czasu oraz do przechowania takiej ilości informacji o stanie, która pozwoli na przywrócenie aplikacji do stanu bieżącego. Jeżeli aplikacja obsługuje działanie w tle, w chwili kończenia działania należy wywołać tę metodę zamiast applicationWillTerminate:.
   */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana podczas przechodzenia aplikacji ze stanu aktywnego do działania w tle. Można więc tutaj wycofać wiele zmian wprowadzonych w chwili przechodzenia do stanu działania w tle.
   */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
  /*
   W tej metodzie można wznowić działanie zadań zatrzymanych (lub nieuruchomionych), gdy aplikacja była nieaktywna. Jeżeli aplikacja znajdowała się w trybie działania w tle, w metodzie można przeprowadzić odświeżenie interfejsu użytkownika.
   */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy działanie aplikacji ma zostać zakończone. Zapoznaj się z opisem metody applicationDidEnterBackground:.
   */
}

@end
