//
//  Typecasting_with_Automatic_Reference_CountingAppDelegate.m
//  Typecasting with Automatic Reference Counting
//
//  Created by Vandad Nahavandipoor on 25/07/2011.
//  Copyright 2011 Pixolity Ltd. All rights reserved.
//

#import "Typecasting_with_Automatic_Reference_CountingAppDelegate.h"

@implementation Typecasting_with_Automatic_Reference_CountingAppDelegate

@synthesize window = _window;

/* 1 */
//- (BOOL)            application:(UIApplication *)application
//  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
//  
//  CFStringRef coreFoundationString = 
//  CFStringCreateWithCString(CFAllocatorGetDefault(), 
//                            "Ciąg tekstowy języka C", 
//                            kCFStringEncodingUTF8);
//  
//  /* Błąd podczas kompilacji!!! */
//  NSString *objCString = coreFoundationString;
//  
//  self.window = [[UIWindow alloc] initWithFrame:
//                 [[UIScreen mainScreen] bounds]];
//  
//  self.window.backgroundColor = [UIColor whiteColor];
//  [self.window makeKeyAndVisible];
//  return YES;
//}

/* 2 */
//- (BOOL)            application:(UIApplication *)application
//  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
//  
//  CFStringRef coreFoundationString = 
//  CFStringCreateWithCString(CFAllocatorGetDefault(), 
//                            "Ciąg tekstowy języka C", 
//                            kCFStringEncodingUTF8);
//  
//  /* Błąd podczas kompilacji!!! */
//  NSString *objCString = (__bridge_transfer NSString *)coreFoundationString;
//  
//  NSLog(@"Ciąg tekstowy = %@", objCString);
//  
//  self.window = [[UIWindow alloc] initWithFrame:
//                 [[UIScreen mainScreen] bounds]];
//  
//  self.window.backgroundColor = [UIColor whiteColor];
//  [self.window makeKeyAndVisible];
//  return YES;
//}

/* 3 */
- (BOOL)            application:(UIApplication *)application
  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
  
  CFStringRef coreFoundationString = 
  CFStringCreateWithCString(CFAllocatorGetDefault(), 
                            "Ciąg tekstowy języka C", 
                            kCFStringEncodingUTF8);
  
  id unknownObjectType = (__bridge id)coreFoundationString;
  
  CFStringRef anotherString = (__bridge_retained CFStringRef)unknownObjectType;
  
  NSString *objCString = (__bridge_transfer NSString *)coreFoundationString;
  NSLog(@"Ciąg tekstowy = %@", objCString);
  objCString = nil;
  
  CFRelease(anotherString);
  
  self.window = [[UIWindow alloc] initWithFrame:
                 [[UIScreen mainScreen] bounds]];
  
  self.window.backgroundColor = [UIColor whiteColor];
  [self.window makeKeyAndVisible];
  return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy aplikacja przechodzi ze stanu aktywnego do nieaktywnego. Może być wywołana w określonych sytuacjach (na przykład w chwili odbywania rozmowy telefonicznej lub po otrzymaniu wiadomości SMS) bądź kiedy użytkownik kończy działanie aplikacji. Metoda rozpoczyna proces przejścia do stanu pozostania w tle. Tę metodę można wykorzystać do wstrzymania wykonywania bieżących zadań, wyłączenia liczników czasu, zmniejszenia liczby klatek generowanych przez OpenGL ES. W grach ta metoda powinna być użyta do wstrzymania gry (pauza).
   */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
  /*
   Tę metodę należy wykorzystać do zwolnienia zasobów współdzielonych, zapisania danych użytkownika, wyzerowania liczników czasu oraz do przechowania takiej ilości informacji o stanie, która pozwoli na przywrócenie aplikacji do stanu bieżącego. Jeżeli aplikacja obsługuje działanie w tle, w chwili kończenia działania należy wywołać tę metodę zamiast applicationWillTerminate:.
   */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana podczas przechodzenia aplikacji ze stanu aktywnego do działania w tle. Można więc tutaj wycofać wiele zmian wprowadzonych w chwili przechodzenia do stanu działania w tle.
   */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
  /*
   W tej metodzie można wznowić działanie zadań zatrzymanych (lub nieuruchomionych), gdy aplikacja była nieaktywna. Jeżeli aplikacja znajdowała się w trybie działania w tle, w metodzie można przeprowadzić odświeżenie interfejsu użytkownika.
   */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy działanie aplikacji ma zostać zakończone. Zapoznaj się z opisem metody applicationDidEnterBackground:.
   */
}

@end
