//
//  Presenting_Multiple_View_Controllers_with_UITabBarControllerAppDelegate.m
//  Presenting Multiple View Controllers with UITabBar
//
//  Created by Vandad Nahavandipoor on 09/07/2011.
//  Copyright 2011 Pixolity Ltd. All rights reserved.
//

#import "Presenting_Multiple_View_Controllers_with_UITabBarControllerAppDelegate.h"
#import "FirstViewController.h"
#import "SecondViewController.h"

@implementation Presenting_Multiple_View_Controllers_with_UITabBarControllerAppDelegate

/* 1 */
//@synthesize window = _window;
//@synthesize firstViewController;
//@synthesize secondViewController;
//@synthesize tabBarController;
//
//- (BOOL)            application:(UIApplication *)application 
//  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
//  
//  // Miejsce na przeprowadzenie własnej konfiguracji po uruchomieniu aplikacji.
//  self.window = [[UIWindow alloc] initWithFrame:
//                 [[UIScreen mainScreen] bounds]];
//  
//  [self.window makeKeyAndVisible];
//  
//  self.firstViewController = [[FirstViewController alloc]
//                              initWithNibName:nil
//                              bundle:NULL];
//  self.secondViewController = [[SecondViewController alloc]
//                               initWithNibName:nil
//                               bundle:NULL];
//  
//  NSArray *twoViewControllers = [[NSArray alloc]
//                                 initWithObjects:
//                                 self.firstViewController,
//                                 self.secondViewController, nil];
//  
//  self.tabBarController = [[UITabBarController alloc] init];
//  [self.tabBarController setViewControllers:twoViewControllers];
//  
//  [self.window addSubview:self.tabBarController.view];
//  
//  return YES;
//  
//}

/* 2 */
@synthesize window = _window;
@synthesize firstViewController;
@synthesize firstNavigationController;
@synthesize secondViewController;
@synthesize secondNavigationController;
@synthesize tabBarController;

- (BOOL)            application:(UIApplication *)application 
  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
  
  // Miejsce na przeprowadzenie własnej konfiguracji po uruchomieniu aplikacji.
  self.window = [[UIWindow alloc] initWithFrame:
                 [[UIScreen mainScreen] bounds]];
  
  [self.window makeKeyAndVisible];
  
  self.firstViewController = [[FirstViewController alloc]
                              initWithNibName:nil
                              bundle:NULL];
  self.firstNavigationController = 
    [[UINavigationController alloc]
     initWithRootViewController:self.firstViewController];
  
  self.secondViewController = [[SecondViewController alloc]
                               initWithNibName:nil
                               bundle:NULL];
  self.secondNavigationController = 
    [[UINavigationController alloc]
     initWithRootViewController:self.secondViewController];
                                     
  NSArray *twoNavControllers = [[NSArray alloc]
                                 initWithObjects:
                                 self.firstNavigationController,
                                 self.secondNavigationController, nil];
  
  self.tabBarController = [[UITabBarController alloc] init];
  [self.tabBarController setViewControllers:twoNavControllers];
  
  [self.window addSubview:self.tabBarController.view];
  
  return YES;
  
}


- (void)applicationWillResignActive:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy aplikacja przechodzi ze stanu aktywnego do nieaktywnego. Może być wywołana w określonych sytuacjach (na przykład w chwili odbywania rozmowy telefonicznej lub po otrzymaniu wiadomości SMS) bądź kiedy użytkownik kończy działanie aplikacji. Metoda rozpoczyna proces przejścia do stanu pozostania w tle. Tę metodę można wykorzystać do wstrzymania wykonywania bieżących zadań, wyłączenia liczników czasu, zmniejszenia liczby klatek generowanych przez OpenGL ES. W grach ta metoda powinna być użyta do wstrzymania gry (pauza).
   */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
  /*
   Tę metodę należy wykorzystać do zwolnienia zasobów współdzielonych, zapisania danych użytkownika, wyzerowania liczników czasu oraz do przechowania takiej ilości informacji o stanie, która pozwoli na przywrócenie aplikacji do stanu bieżącego. Jeżeli aplikacja obsługuje działanie w tle, w chwili kończenia działania należy wywołać tę metodę zamiast applicationWillTerminate:.
   */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana podczas przechodzenia aplikacji ze stanu aktywnego do działania w tle. Można więc tutaj wycofać wiele zmian wprowadzonych w chwili przechodzenia do stanu działania w tle.
   */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
  /*
   W tej metodzie można wznowić działanie zadań zatrzymanych (lub nieuruchomionych), gdy aplikacja była nieaktywna. Jeżeli aplikacja znajdowała się w trybie działania w tle, w metodzie można przeprowadzić odświeżenie interfejsu użytkownika.
   */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy działanie aplikacji ma zostać zakończone. Zapoznaj się z opisem metody applicationDidEnterBackground:.
   */
}

@end
